<template>
  <div class="wrapper">
    <div class="col-2 buttons-wrapper">
      <div class="form-group">
        <div
          class="btn-group-vertical buttons"
          role="group"
          aria-label="Basic example"
        >
          <button class="btn btn-secondary" @click="addRack">Add Oscillator track</button>
          <button class="btn btn-secondary" @click="addMicrophoneRack">Add Microphone track</button>
        </div>
      </div>
    </div>
    <div class="draggable-box">
      <div class="col-6 mounted-modules">
        <h3>Draggable {{ draggingInfo }}</h3>
        <div class="dragdrop-row" v-for="(rack, rackIndex) in rackList" :key="rack.id">
          <div class="rack-controls" v-if="getType(rack) == 'oscillator'">
            <button class="btn-secondary" @click="rack.pause()" v-if="!rack.paused">Pause</button>
            <button class="btn-secondary" @click="rack.resume()" v-if="rack.paused">Resume</button>
          </div>
          <div class="row-wrapper">
            <div class="list-group-item end-item">
              <oscillator-wrapper :node="rack.source" v-if="getType(rack) == 'oscillator'" />
              <microphone-wrapper :node="rack.source" v-if="getType(rack) == 'microphone'" />
            </div>
            <draggable
              :list="rack.nodes"
              item-key="name"
              class="list-group"
              ghost-class="ghost"
              group="webAudioModules"
              :move="checkMove"
              @start="dragging = true"
              @end="dragging = false"
              @change="updateList(rack)"
            >
              <template #item="{ element, index }">
                <div class="list-group-item mid-item">
                  <div>{{ element.name }}</div>
                  <gain-node-wrapper :node="element" v-if="element.type == 'gain'" />
                  <filter-wrapper :node="element" v-if="element.type == 'filter'" />
                  <button @click="removeItem(rackIndex, index)">Delete</button>
                </div>
              </template>
            </draggable>
            <div class="list-group-item end-item">
              <div>{{ rack.destination.name }}</div>
            </div>
          </div>
          <button class="btn-secondary" @click="removeRack(rackIndex)">Delete rack</button>
        </div>
      </div>
      <div class="avalaible-modules">
        <h3>Menu</h3>
        <draggable
          :list="modules"
          :group="{ name: 'webAudioModules', pull: 'clone', put: false }"
          item-key="name"
        >
          <template #item="{ element }">
            <div class="module-item">
              {{ element.name }}
            </div>
          </template>
        </draggable>
      </div>
    </div>
  </div>
</template>

<script>
import { AudioTrack } from '@/lib/audio/AudioTrack';
import { NodeWrapper } from '@/lib/audio/NodeWrapper';
import { MicrophoneRack } from '@/lib/audio/MicrophoneRack';
import draggable from 'vuedraggable'
import GainNodeWrapper from './nodes/GainNodeWrapper.vue'
import OscillatorWrapper from './nodes/OscillatorWrapper.vue'
import DestinationWrapper from './nodes/DestinationWrapper.vue'
import MicrophoneWrapper from './nodes/MicrophoneWrapper.vue'
import FilterWrapper from './nodes/FilterWrapper.vue'

let id = 1;
let rackId = 1;
export default {
  name: "DragDropExample",
  order: 0,
  components: {
    draggable,
    GainNodeWrapper,
    OscillatorWrapper,
    DestinationWrapper,
    MicrophoneWrapper,
    FilterWrapper,
  },
  data() {
    return {
      rackList: [],
      audioContext: null,
      modules: [
        
      ],
      dragging: false,
      options: {
        audio: true,
        video: false
      }
    };
  },
  computed: {
    draggingInfo() {
      return this.dragging ? "under drag" : "";
    }
  },
  methods: {
    getType(rack) {
      return rack.source.type
    },
    checkMove: function(e) {
      window.console.log("Future index: " + e.draggedContext.futureIndex);
    },
    removeItem: function(rackIndex, index) {
      this.rackList[rackIndex].nodes.splice(index, 1);
      this.rackList[rackIndex].refresh();
    },
    createGain() {
      const gain = this.audioContext.createGain();
      gain.gain.value = 0.5;
      return gain;
    },
    createFilter() {
      const f = this.audioContext.createBiquadFilter();
      f.type = 'lowpass';
      f.frequency.value = 1000;
      f.gain.value = 25;
      f.Q.value = 0.001;
      return f;
    },
    initModules() {
      console.log(this.audioContext)
      if (this.audioContext === undefined || this.audioContext === null) {
        this.audioContext = new AudioContext();
        this.modules.push(new NodeWrapper(this.createGain(), 'gain', 'Volume'))
        this.modules.push(new NodeWrapper(this.createFilter(), 'filter', 'Filter'))
      }
    },
    addRack: function() {
      this.initModules()
      const track = new AudioTrack()
      track.init(this.audioContext)
      track.start();
      this.rackList.push(track);
    },
    addMicrophoneRack() {
      this.initModules()
      const track = new MicrophoneRack()
      navigator.mediaDevices.getUserMedia(this.options).then(stream => {
        track.init(this.audioContext)
        const mic = track.context.createMediaStreamSource(stream);
        track.source = new NodeWrapper(mic, 'microphone', 'Microphone');
        track.source.node.connect(track.destination.node)
        this.rackList.push(track);
      })
    },
    removeRack: function(rackIndex) {
      this.rackList[rackIndex].stop();
      this.rackList.splice(rackIndex, 1);
    },
    updateList(rack) {
      rack.refresh()
    }
  }
};
</script>
<style scoped>
.wrapper {
    width: 1200px;
    min-height: 100vh;
    background-color: #eceff1;
    border-left: 10px solid #cfd8dc;
    border-right: 10px solid #cfd8dc;
    margin: 0 auto;
}
.buttons-wrapper {
  border-bottom: 10px solid #cfd8dc;
  padding-bottom: 20px;
}
.btn-secondary {
  background-color: #cfd8dc;
  border: solid 2px #607d8b;
  padding: 10px;
  margin: 0 10px;
  cursor: pointer;
}
.buttons {
  padding-top: 35px;
}
.ghost {
  opacity: 0.5;
  background: #c8ebfb;
}
.not-draggable {
  cursor: no-drop;
}
.list-group {
  display: flex;
}
.list-group-item {
  min-width: 100px;
  height: 100px;
  margin: 5px;
  padding: 5px 10px;
  border: solid 1px black;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}
.dragdrop-row {
  border: solid 1px black;
  padding: 4px;
  margin: 10px;
  min-height: 30px;
  background-color: white;
  border: 1px solid #cfd8dc;
}

.dragdrop-row > .row-wrapper {
  display: flex;
}
.draggable-box {
  display: flex;
}
.mounted-modules {
  padding: 8px;
  padding-left: 0px;
  width: 80%;
}
.avalaible-modules {
  padding: 8px;
  width: 20%;
  border-left: 10px solid #cfd8dc;
  border-bottom: 10px solid #cfd8dc;
  border-top: none;
}
.module-item {
  padding: 8px;
  background-color: white;
  border: 1px solid #cfd8dc;
  margin-bottom: 10px;
  cursor: grab;
}

.mid-item {
  background-color: #e1f5fe;
  border: 1px solid #b3e5fc;
}

.end-item {
  background-color: #e8f5e9;
  border: 1px solid #c8e6c9;
}
</style>
